curl --request POST \
--url https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"direction": "Z+",
"isp": 300,
"maxBurnTime": 3600,
"name": "Main Engine",
"thrust": 500,
"x": 0,
"y": 0,
"z": -1.5
}
'import requests
url = "https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters"
payload = {
"direction": "Z+",
"isp": 300,
"maxBurnTime": 3600,
"name": "Main Engine",
"thrust": 500,
"x": 0,
"y": 0,
"z": -1.5
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
direction: 'Z+',
isp: 300,
maxBurnTime: 3600,
name: 'Main Engine',
thrust: 500,
x: 0,
y: 0,
z: -1.5
})
};
fetch('https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'direction' => 'Z+',
'isp' => 300,
'maxBurnTime' => 3600,
'name' => 'Main Engine',
'thrust' => 500,
'x' => 0,
'y' => 0,
'z' => -1.5
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters"
payload := strings.NewReader("{\n \"direction\": \"Z+\",\n \"isp\": 300,\n \"maxBurnTime\": 3600,\n \"name\": \"Main Engine\",\n \"thrust\": 500,\n \"x\": 0,\n \"y\": 0,\n \"z\": -1.5\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"direction\": \"Z+\",\n \"isp\": 300,\n \"maxBurnTime\": 3600,\n \"name\": \"Main Engine\",\n \"thrust\": 500,\n \"x\": 0,\n \"y\": 0,\n \"z\": -1.5\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"direction\": \"Z+\",\n \"isp\": 300,\n \"maxBurnTime\": 3600,\n \"name\": \"Main Engine\",\n \"thrust\": 500,\n \"x\": 0,\n \"y\": 0,\n \"z\": -1.5\n}"
response = http.request(request)
puts response.read_body{
"createdAt": "2025-10-22T10:30:00Z",
"direction": "Z+",
"id": "550e8400-e29b-41d4-a716-446655440000",
"isp": 300,
"maxBurnTime": 3600,
"name": "Main Engine",
"spacecraftId": "spacecraft-123",
"thrust": 500,
"type": "CHEMICAL",
"updatedAt": "2025-10-22T15:45:00Z",
"x": 0,
"y": 0,
"z": -1.5
}{
"code": "import.tracking.tdm.parse_failed",
"correlationId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"details": {},
"error": "Bad Request",
"fieldErrors": {},
"message": "Invalid spacecraft ID format",
"params": {},
"path": "/api/v1/stm/credentials",
"status": 400,
"timestamp": "2025-11-14T10:15:30.123Z"
}{
"error": "invalid_token",
"error_description": "An error occurred while attempting to decode the Jwt"
}{
"code": "import.tracking.tdm.parse_failed",
"correlationId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"details": {},
"error": "Bad Request",
"fieldErrors": {},
"message": "Invalid spacecraft ID format",
"params": {},
"path": "/api/v1/stm/credentials",
"status": 400,
"timestamp": "2025-11-14T10:15:30.123Z"
}{
"code": "import.tracking.tdm.parse_failed",
"correlationId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"details": {},
"error": "Bad Request",
"fieldErrors": {},
"message": "Invalid spacecraft ID format",
"params": {},
"path": "/api/v1/stm/credentials",
"status": 400,
"timestamp": "2025-11-14T10:15:30.123Z"
}Create a thruster
Creates a thruster under a parent spacecraft resolved strictly by id. Type is auto-computed from ISP and rendered UPPER_CASE (DT-17). Returns 404 if the parent spacecraft does not exist.
curl --request POST \
--url https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"direction": "Z+",
"isp": 300,
"maxBurnTime": 3600,
"name": "Main Engine",
"thrust": 500,
"x": 0,
"y": 0,
"z": -1.5
}
'import requests
url = "https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters"
payload = {
"direction": "Z+",
"isp": 300,
"maxBurnTime": 3600,
"name": "Main Engine",
"thrust": 500,
"x": 0,
"y": 0,
"z": -1.5
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
direction: 'Z+',
isp: 300,
maxBurnTime: 3600,
name: 'Main Engine',
thrust: 500,
x: 0,
y: 0,
z: -1.5
})
};
fetch('https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'direction' => 'Z+',
'isp' => 300,
'maxBurnTime' => 3600,
'name' => 'Main Engine',
'thrust' => 500,
'x' => 0,
'y' => 0,
'z' => -1.5
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters"
payload := strings.NewReader("{\n \"direction\": \"Z+\",\n \"isp\": 300,\n \"maxBurnTime\": 3600,\n \"name\": \"Main Engine\",\n \"thrust\": 500,\n \"x\": 0,\n \"y\": 0,\n \"z\": -1.5\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"direction\": \"Z+\",\n \"isp\": 300,\n \"maxBurnTime\": 3600,\n \"name\": \"Main Engine\",\n \"thrust\": 500,\n \"x\": 0,\n \"y\": 0,\n \"z\": -1.5\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.valar.space/operations/spacecraft/{spacecraftId}/thrusters")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"direction\": \"Z+\",\n \"isp\": 300,\n \"maxBurnTime\": 3600,\n \"name\": \"Main Engine\",\n \"thrust\": 500,\n \"x\": 0,\n \"y\": 0,\n \"z\": -1.5\n}"
response = http.request(request)
puts response.read_body{
"createdAt": "2025-10-22T10:30:00Z",
"direction": "Z+",
"id": "550e8400-e29b-41d4-a716-446655440000",
"isp": 300,
"maxBurnTime": 3600,
"name": "Main Engine",
"spacecraftId": "spacecraft-123",
"thrust": 500,
"type": "CHEMICAL",
"updatedAt": "2025-10-22T15:45:00Z",
"x": 0,
"y": 0,
"z": -1.5
}{
"code": "import.tracking.tdm.parse_failed",
"correlationId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"details": {},
"error": "Bad Request",
"fieldErrors": {},
"message": "Invalid spacecraft ID format",
"params": {},
"path": "/api/v1/stm/credentials",
"status": 400,
"timestamp": "2025-11-14T10:15:30.123Z"
}{
"error": "invalid_token",
"error_description": "An error occurred while attempting to decode the Jwt"
}{
"code": "import.tracking.tdm.parse_failed",
"correlationId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"details": {},
"error": "Bad Request",
"fieldErrors": {},
"message": "Invalid spacecraft ID format",
"params": {},
"path": "/api/v1/stm/credentials",
"status": 400,
"timestamp": "2025-11-14T10:15:30.123Z"
}{
"code": "import.tracking.tdm.parse_failed",
"correlationId": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"details": {},
"error": "Bad Request",
"fieldErrors": {},
"message": "Invalid spacecraft ID format",
"params": {},
"path": "/api/v1/stm/credentials",
"status": 400,
"timestamp": "2025-11-14T10:15:30.123Z"
}Authorizations
API Key (format: vsp_sk_...)
Path Parameters
Parent spacecraft id
Body
Request to create a new thruster for a spacecraft
Thrust direction in 3D coordinate system
X+, X-, Y+, Y-, Z+, Z- ^(X[+-]|Y[+-]|Z[+-])$"Z+"
Specific impulse in seconds (s). Used to auto-compute type: ISP < 800 = chemical, ISP >= 800 = electric
x > 0.001300
Maximum continuous burn duration in seconds (s)
x > 0.0013600
Thruster name (unique per spacecraft)
100"Main Engine"
Maximum thrust in Newtons (N)
x > 0500
Thruster position X coordinate in meters (m) relative to spacecraft center of mass. Can be negative.
0
Thruster position Y coordinate in meters (m) relative to spacecraft center of mass. Can be negative.
0
Thruster position Z coordinate in meters (m) relative to spacecraft center of mass. Can be negative.
-1.5
Response
Thruster created successfully
Thruster response data
Timestamp when thruster was created
"2025-10-22T10:30:00Z"
Thrust direction in 3D coordinate system
X+, X-, Y+, Y-, Z+, Z- "Z+"
Thruster unique identifier (UUID)
"550e8400-e29b-41d4-a716-446655440000"
Specific impulse in seconds (s)
300
Maximum continuous burn duration in seconds (s)
3600
Thruster name (unique per spacecraft)
"Main Engine"
Spacecraft ID this thruster belongs to
"spacecraft-123"
Maximum thrust in Newtons (N)
500
Propulsion type (auto-computed from ISP), rendered UPPER_CASE per DT-17
CHEMICAL, ELECTRIC "CHEMICAL"
Timestamp when thruster was last updated
"2025-10-22T15:45:00Z"
Position X coordinate in meters (m)
0
Position Y coordinate in meters (m)
0
Position Z coordinate in meters (m)
-1.5
Was this page helpful?